import { Merchant } from './Merchant';
import { CreditCardPeriodActionParams, CreditCardPeriodActionResponseData, DoActionParams, DoActionResponseData } from '../types';
export declare class Action<T> {
    merchant: Merchant;
    apiUrl?: string;
    params: T;
    _params?: object;
    constructor(merchant: Merchant, params: T);
    _execute<T>(): Promise<T>;
}
export declare class CreditCardPeriodAction extends Action<CreditCardPeriodActionParams> {
    _params: CreditCardPeriodActionParams & {
        TimeStamp: number;
        PlatformID?: string;
    };
    constructor(merchant: Merchant, params: CreditCardPeriodActionParams);
    execute(): Promise<CreditCardPeriodActionResponseData>;
}
export declare class DoAction extends Action<DoActionParams> {
    _params: DoActionParams & {
        PlatformID?: string;
    };
    constructor(merchant: Merchant, params: DoActionParams);
    execute(): Promise<DoActionResponseData>;
}
